> For the complete documentation index, see [llms.txt](https://docs.pakk.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pakk.io/data-and-integrations/api/integration-data-key-value-store.md).

# Integration Data (Key-Value Store)

Integrations have access to a namespaced key-value store to which proprietary data can be written on any record of any entity

* This field is always called `integrationsData.{{integrationName}}` where `{{integrationsName}}` is the name of the integration as set up in *Account Settings*
* An integration can only write to its own namespace - any attempts to write to any other namespace will fail
* You **do not** have to send the entire contents of the KV store for that integration when patching `integrationsData.{{integrationName}}`. For example, if you want to set the value of `key1` to `val1`, you only need to send `integrationsData.{{integrationName}}.key1: val1` - none of the other keys in the namespace will be affected
* The key-value store is intended for writing identifiers, flags and other small pieces of data - it is not meant to be used as a fully-fledged database
* An integration can write up to 20 keys per record
* Maximum key size is 64 bytes
* Maximum value size is 1024 bytes


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.pakk.io/data-and-integrations/api/integration-data-key-value-store.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
